package com.framsticks.diagnostics;

import org.apache.commons.configuration.Configuration;

import com.framsticks.observers.Endpoint;
import com.framsticks.observers.Observer;

/**
 * @author Piotr Sniegowski
 */
public class Diagnostics extends Observer {

	Integer dumpsInterval;
	String dumpsPath;
	String dumpsFormat;


	public Diagnostics() {
	}

	@Override
	public void configure(Configuration config) {
		super.configure(config);
		dumpsInterval = config.getInteger("dumps.interval", null);
		dumpsPath = config.getString("dumps.path", null);
		dumpsFormat = config.getString("dumps.format", null);
	}


	@Override
	protected Endpoint createEndpoint() {
		return new DiagnosticsEndpoint();
	}


}
