package com.framsticks.gui;

import com.framsticks.util.dispatching.Dispatcher;
import com.framsticks.util.dispatching.Task;

import javax.swing.*;

/**
 * @author Piotr Sniegowski
 */
public class SwingDispatcher implements Dispatcher {

	public static final SwingDispatcher instance = new SwingDispatcher();

	public SwingDispatcher() {
		invokeLater(new Runnable() {
			@Override
			public void run() {
				Thread.currentThread().setName("gui");
			}
		});
	}

	@Override
	public final boolean isActive() {
		return SwingUtilities.isEventDispatchThread();
	}

	@Override
	public final void invokeLater(Runnable runnable) {
		assert !(runnable instanceof Task);
		SwingUtilities.invokeLater(runnable);
	}

}
