package com.framsticks.params;

import com.framsticks.util.lang.Strings;

/**
 * @author Piotr Sniegowski
 */
public abstract class CompositeParam extends ValueParam {
	protected final String containedTypeName;

	public CompositeParam(String containedTypeName) {
		this.containedTypeName = Strings.notEmpty(containedTypeName) ? containedTypeName : null;
	}

	public boolean isMatchingContainedName(String name) {
		assert name != null;
		if (containedTypeName == null) {
			return true;
		}
		return name.equals(containedTypeName);
	}

	public String getContainedTypeName() {
		return containedTypeName;
	}

	public abstract AccessInterface prepareAccessInterface(AccessInterface access);

	public abstract String computeAccessId();

	public <T> T getDef(Class<T> type) throws ClassCastException {
		return null;
	}

}
