package com.framsticks.params.types;

import com.framsticks.params.CastFailure;
import com.framsticks.params.ReassignResult;

/**
 * @author Piotr Sniegowski
 */
public class FloatParam extends NumberParam<Double> {

	public FloatParam() {
		def = 0.0;
	}

	@Override
	public Class<?> getStorageType() {
		return Double.class;
	}

	@Override
	public ReassignResult<Double> reassign(Object newValue, Object oldValue) throws CastFailure {
		return reassignNumber(newValue, oldValue, Double.class);
	}

	@Override
	public String getFramsTypeName() {
		return "f";
	}


}
