package com.framsticks.params.types;

import com.framsticks.params.AccessInterface;
import com.framsticks.params.CastFailure;
import com.framsticks.params.CompositeParam;
import com.framsticks.params.ReassignResult;

/**
 * @author Piotr Sniegowski
 */
public class ObjectParam extends CompositeParam {

	public ObjectParam(String containedTypeName) {
		super(containedTypeName);
	}

	@Override
	public String computeAccessId() {
		return containedTypeName;
	}

	@Override
	public Class<?> getStorageType() {
		return Object.class;
	}

	@Override
	public ReassignResult<Object> reassign(Object newValue, Object oldValue) throws CastFailure {
		return ReassignResult.create(newValue);
	}

	@Override
	public AccessInterface prepareAccessInterface(AccessInterface access) {
		return access;
	}

	@Override
	public String getFramsTypeName() {
		return "o " + containedTypeName;
	}

}
